### Hierarchy

- Selector

## Index

### Constructors

- constructor

### Properties

- clauses
- logger
- selector_compiled
- AGG_FIELD_SELECTOR
- FIELD_SELECTOR
- MATCH_SELECTOR
- SORT_SELECTOR

### Methods

- ___buildDocumentSelector
- ___buildKeypathSelector
- ___buildSelector
- compile
- compileFields
- compileSort
- test
- isSelectorCompiled
- matches

## Constructors

### constructor

- new Selector(selector: any, type?: string): Selector

- - Defined in selector/Selector.ts:25

  #### Parameters

  - ##### selector: any

  - ##### Default value type: string = Selector.MATCH_SELECTOR

  #### Returns Selector

## Properties

### clauses

clauses: any

- Defined in selector/Selector.ts:25

### Protected logger

logger: JSWLogger

- Defined in selector/Selector.ts:17

### selector_compiled

selector_compiled: any

- Defined in selector/Selector.ts:24

### Static AGG_FIELD_SELECTOR

AGG_FIELD_SELECTOR: string = "project"

- Defined in selector/Selector.ts:22

### Static FIELD_SELECTOR

FIELD_SELECTOR: string = "field"

- Defined in selector/Selector.ts:21

### Static MATCH_SELECTOR

MATCH_SELECTOR: string = "match"

- Defined in selector/Selector.ts:19

### Static SORT_SELECTOR

SORT_SELECTOR: string = "sort"

- Defined in selector/Selector.ts:20

## Methods

### Private ___buildDocumentSelector

- ___buildDocumentSelector(key: any, value: any): Clause

- - Defined in selector/Selector.ts:67

  #### Parameters

  - ##### key: any

  - ##### value: any

  #### Returns Clause

### Private ___buildKeypathSelector

- ___buildKeypathSelector(keypath: any, value: any): Clause

- - Defined in selector/Selector.ts:99

  #### Parameters

  - ##### keypath: any

  - ##### value: any

  #### Returns Clause

### Private ___buildSelector

- ___buildSelector(selector: any): Array<any>

- - Defined in selector/Selector.ts:45

  #### Parameters

  - ##### selector: any

  #### Returns Array<any>

### compile

- compile(selector: any): SelectorMatcher

- - Defined in selector/Selector.ts:194

  #### Parameters

  - ##### selector: any

  #### Returns SelectorMatcher

### compileFields

- compileFields(spec: any, aggregation: any): any

- - Defined in selector/Selector.ts:369

  #### Parameters

  - ##### spec: any

  - ##### aggregation: any

  #### Returns any

### compileSort

- compileSort(spec: any): any

- - Defined in selector/Selector.ts:246

  #### Parameters

  - ##### spec: any

  #### Returns any

### test

- test(doc: any): any

- - Defined in selector/Selector.ts:190

  #### Parameters

  - ##### doc: any

  #### Returns any

### Static isSelectorCompiled

- isSelectorCompiled(selector: any): boolean

- - Defined in selector/Selector.ts:460

  #### Parameters

  - ##### selector: any

  #### Returns boolean

### Static matches

- matches(selector: any, doc: any): any

- - Defined in selector/Selector.ts:471

  #### Parameters

  - ##### selector: any

  - ##### doc: any

  #### Returns any

Generated using TypeDoc